<?php
// Credit Louviaux Jean-Marc 2015
define('checkaccess', TRUE);
include('../config/config_main.php');
date_default_timezone_set($DTZ);

if (isset($_COOKIE['user_lang'])) {
    $user_lang = $_COOKIE['user_lang'];
} else {
    $user_lang = 'English';
}

include('../languages/' . $user_lang . '.php');

if (!empty($_GET['meter'])) {
    $meter = $_GET['meter']; //1Elect
} else {
	die ();
}

$metnum = substr($meter, 0, 1);
if (file_exists("../config/config_met$metnum.php")) {
	include("../config/config_met$metnum.php");	
} else {
	die ();
}

$dir = '../data/meters/';

$meteryearlist = array();
$meteryearlist = glob($dir . "$meter*.csv"); // 1Elect*
if (is_array($meteryearlist)) {
    sort($meteryearlist);
}
$yearscnt = count($meteryearlist);

$topseries[0]['id']   = 'toplevel';
$topseries[0]['name'] = substr($meter, 1);

$ncnt = 0;
for ($i = 0; $i < $yearscnt; $i++) {
    $dir               = '../data/meters/';
    $year              = substr($meteryearlist[$i], -8, 4);

    $thefile    = file($dir . $meter . $year . '.csv');
    $contalines = count($thefile);
    $year       = (int) $year;
    
    for ($line_num = 0; $line_num < $contalines; $line_num++) {
        $array                    = preg_split("/,/", $thefile[$line_num]);
        $month                    = substr($array[0], 0, 2);
        $day                      = substr($array[0], 2, 2);
        $month                    = (int) ($month);
        $m                        = $month - 1;
        $day                      = (int) ($day);
        $d                        = $day - 1;
        $conso_day[$year][$m][$d] = (float) ($array[1]);
        if (${'TYPE' . $metnum} == 'Elect') {
            $conso_day[$year][$m][$d] /= 1000;
        }
        $drilldowndays[$year][$m][$d] = array(
            'name' => "$day",
            'y' => $conso_day[$year][$m][$d]
        );
    } // end of looping through the file	
    
    if ($year == date('Y')) { // Add today conso
        $dir    = '../data/csv/';
        $output = glob($dir . '*.csv');
        rsort($output);
        if (isset($output[0])) {
            $file       = file($output[0]);
            $month      = substr($output[0], -8, 2);
            $day        = substr($output[0], -6, 2);
            $contalines = count($file);
            $prevarray  = preg_split('/,/', $file[1]);
            $linearray  = preg_split('/,/', $file[$contalines - 1]);
            $met        = substr($meter, 0, 1);
            $val_first  = $prevarray[$met];
            $val_last   = $linearray[$met];
            settype($val_first, 'float');
            settype($val_last, 'float');
            
            if ($val_first <= $val_last) {
                $val_last -= $val_first;
            } else { // counter pass over
                $val_last += ${'PASSO' . $metnum} - $val_first;
            }
            
            $month                    = (int) ($month);
            $m                        = $month - 1;
            $day                      = (int) ($day);
            $d                        = $day - 1;
            $conso_day[$year][$m][$d] = (float) ($val_last);
            if (${'TYPE' . $metnum} == 'Elect') {
                $conso_day[$year][$m][$d] /= 1000;
            }
            $drilldowndays[$year][$m][$d] = array(
                'name' => "$day",
                'y' => $conso_day[$year][$m][$d]
            );
        }
    } // end of today conso
    
    $conso_y = 0;
    $stmonth = 1;
    for ($h = 0; $h < 12; $h++) { // Fill blanks dates
        $daythatm = cal_days_in_month(CAL_GREGORIAN, $stmonth, $year);
        for ($j = 0; $j < $daythatm; $j++)
            if (!isset($conso_day[$year][$h][$j])) {
				$conso_day[$year][$h][$j] =0;
                $d                            = $j + 1;
                $h                            = (int) $h;
                $j                            = (int) $j;
                $drilldowndays[$year][$h][$j] = array(
                    'name' => "$d",
                    'y' => 0
                );
            }
        $stmonth++;
		$conso_y += array_sum($conso_day[$year][$h]);
    }
    $title = "${'METNAME'.$metnum} $year: ";
    if (${'TYPE' . $metnum} == 'Elect') {
        $title .= number_format($conso_y, 1, $DPOINT, $THSEP);
        $title .= " kWh";
    } else {
        $title .= number_format($conso_y, ${'PRECI' . $metnum}, $DPOINT, $THSEP);
        $title .= " ${'UNIT'.$metnum}";
    }
    
    if (${'PRICE' . $metnum} > 0) {
        $money = number_format(($conso_y * ${'PRICE' . $metnum}), 1, $DPOINT, $THSEP);
        $title .= "/$money $CURS";
    }
    
    $topseries[0]['data'][$i] = array(
        'name' => $year,
        'y' => $conso_y,
        'drilldown' => 'y' . $year, //y2015
        'title' => $title
    );
    
    $m = 1;
    for ($h = 0; $h < 12; $h++) { // each h month
        $conso_m = array_sum($conso_day[$year][$h]);
        sort($drilldowndays[$year][$h]); // ici
        $title = "${'METNAME'.$metnum} $lgMONTH[$m] $year: ";
        if (${'TYPE' . $metnum} == 'Elect') {
            $title .= number_format($conso_m, 1, $DPOINT, $THSEP);
            $title .= ' kWh';
        } else {
            $title .= number_format($conso_m, ${'PRECI' . $metnum}, $DPOINT, $THSEP);
            $title .= " ${'UNIT'.$metnum}";
        }
        if (${'PRICE' . $metnum} > 0) {
            $money = number_format(($conso_m * ${'PRICE' . $metnum}), 1, $DPOINT, $THSEP);
            $title .= "/$money $CURS";
        }
        $drilldownmonths[$year][$h] = array(
            'name' => "$lgSMONTH[$m]",
            'y' => $conso_m,
            'drilldown' => 'm' . $year . $m, // id201508
            'title' => $title
        );
        
        if ($h == 0) {
            $return['series'][$ncnt]['id']   = 'y' . $year; //y2015
            $return['series'][$ncnt]['name'] = "$year";
            $thisy                           = $ncnt;
            $ncnt++;
        }
        $return['series'][$ncnt]['id']   = 'm' . $year . $m; //id201508
        $return['series'][$ncnt]['name'] = "$lgSMONTH[$m] $year";
        $return['series'][$ncnt]['data'] = $drilldowndays[$year][$h];
        $m++;
        $ncnt++;
    } // each month
    
    $return['series'][$thisy]['data'] = $drilldownmonths[$year];
} // each year file

$return1[0] = $topseries;

$jsonreturn = array(
    'series' => $return1[0],
    'drilldown' => $return
);

header("Content-type: text/json");
echo json_encode($jsonreturn);
?>
